/*
 * include/linux/led_pxa_e680.h
 * 
 * Copyright (C) 2003-2004 Motorola
 *
 * Support E680 Network && BT indicator LED 
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *                                                                                               
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * 2003-Dec-10 - (Motorola) File created
 * 2004-Aug-4 - (Motorola) Changed enum to change LED intervals
 */

#ifndef LED_PXA_E680_H
#define LED_PXA_E680_H

#include <linux/led.h>

enum
{
LED_OFF = 0,

LED_RED_ALWAYS_ON,
LED_GREEN_ALWAYS_ON,
LED_BLUE_ALWAYS_ON,
LED_LIGHT_RED_ALWAYS_ON,
LED_ORANGE_ALWAYS_ON,
LED_LIGHT_BLUE_ALWAYS_ON,
LED_WHITE_ALWAYS_ON,

LED_RED_01_ON_19_OFF,
LED_RED_02_ON_18_OFF,
LED_RED_05_ON_15_OFF,
LED_RED_025_ON_075_OFF,
LED_RED_025_ON_175_OFF,
LED_RED_005_ON_195_OFF,
LED_RED_05_ON_05_OFF,
LED_RED_05_OFF_05_ON,
LED_RED_0125_ON_05_OFF_0075_ON_15_OFF,
LED_RED_0125_ON_2075_OFF,
LED_RED_0625_OFF_0075_ON_15_OFF,

LED_RED_01_ON_19_OFF_SKIP,
LED_RED_02_ON_18_OFF_SKIP,
LED_RED_05_ON_15_OFF_SKIP,
LED_RED_025_ON_075_OFF_SKIP,
LED_RED_025_ON_175_OFF_SKIP,
LED_RED_005_ON_195_OFF_SKIP,
LED_RED_05_ON_05_OFF_SKIP,
LED_RED_05_OFF_05_ON_SKIP,
LED_RED_0125_ON_05_OFF_0075_ON_15_OFF_SKIP,
LED_RED_0125_ON_2075_OFF_SKIP,
LED_RED_0625_OFF_0075_ON_15_OFF_SKIP,

LED_GREEN_01_ON_19_OFF,
LED_GREEN_02_ON_18_OFF,
LED_GREEN_05_ON_15_OFF,
LED_GREEN_025_ON_075_OFF,
LED_GREEN_025_ON_175_OFF,
LED_GREEN_005_ON_195_OFF,
LED_GREEN_05_ON_05_OFF,
LED_GREEN_05_OFF_05_ON,
LED_GREEN_0125_ON_05_OFF_0075_ON_15_OFF,
LED_GREEN_0125_ON_2075_OFF,
LED_GREEN_0625_OFF_0075_ON_15_OFF,

LED_GREEN_01_ON_19_OFF_SKIP,
LED_GREEN_02_ON_18_OFF_SKIP,
LED_GREEN_05_ON_15_OFF_SKIP,
LED_GREEN_025_ON_075_OFF_SKIP,
LED_GREEN_025_ON_175_OFF_SKIP,
LED_GREEN_005_ON_195_OFF_SKIP,
LED_GREEN_05_ON_05_OFF_SKIP,
LED_GREEN_05_OFF_05_ON_SKIP,
LED_GREEN_0125_ON_05_OFF_0075_ON_15_OFF_SKIP,
LED_GREEN_0125_ON_2075_OFF_SKIP,
LED_GREEN_0625_OFF_0075_ON_15_OFF_SKIP,

LED_BLUE_01_ON_19_OFF,
LED_BLUE_02_ON_18_OFF,
LED_BLUE_05_ON_15_OFF,
LED_BLUE_025_ON_075_OFF,
LED_BLUE_025_ON_175_OFF,
LED_BLUE_005_ON_195_OFF,
LED_BLUE_05_ON_05_OFF,
LED_BLUE_05_OFF_05_ON,
LED_BLUE_0125_ON_05_OFF_0075_ON_15_OFF,
LED_BLUE_0125_ON_2075_OFF,
LED_BLUE_0625_OFF_0075_ON_15_OFF,

LED_BLUE_01_ON_19_OFF_SKIP,
LED_BLUE_02_ON_18_OFF_SKIP,
LED_BLUE_05_ON_15_OFF_SKIP,
LED_BLUE_025_ON_075_OFF_SKIP,
LED_BLUE_025_ON_175_OFF_SKIP,
LED_BLUE_005_ON_195_OFF_SKIP,
LED_BLUE_05_ON_05_OFF_SKIP,
LED_BLUE_05_OFF_05_ON_SKIP,
LED_BLUE_0125_ON_05_OFF_0075_ON_15_OFF_SKIP,
LED_BLUE_0125_ON_2075_OFF_SKIP,
LED_BLUE_0625_OFF_0075_ON_15_OFF_SKIP,

LED_ORANGE_01_ON_19_OFF,
LED_ORANGE_02_ON_18_OFF,
LED_ORANGE_05_ON_15_OFF,
LED_ORANGE_025_ON_075_OFF,
LED_ORANGE_025_ON_175_OFF,
LED_ORANGE_005_ON_195_OFF,
LED_ORANGE_05_ON_05_OFF,
LED_ORANGE_05_OFF_05_ON,
LED_ORANGE_0125_ON_05_OFF_0075_ON_15_OFF,
LED_ORANGE_0125_ON_2075_OFF,
LED_ORANGE_0625_OFF_0075_ON_15_OFF,

LED_ORANGE_01_ON_19_OFF_SKIP,
LED_ORANGE_02_ON_18_OFF_SKIP,
LED_ORANGE_05_ON_15_OFF_SKIP,
LED_ORANGE_025_ON_075_OFF_SKIP,
LED_ORANGE_025_ON_175_OFF_SKIP,
LED_ORANGE_005_ON_195_OFF_SKIP,
LED_ORANGE_05_ON_05_OFF_SKIP,
LED_ORANGE_05_OFF_05_ON_SKIP,
LED_ORANGE_0125_ON_05_OFF_0075_ON_15_OFF_SKIP,
LED_ORANGE_0125_ON_2075_OFF_SKIP,
LED_ORANGE_0625_OFF_0075_ON_15_OFF_SKIP,

LED_RED_0125_ON_2075_OFF_BLUE_0625_OFF_0075_ON_15_OFF,
LED_GREEN_0125_ON_2075_OFF_BLUE_0625_OFF_0075_ON_15_OFF,
LED_ORANGE_0125_ON_2075_OFF_BLUE_0625_OFF_0075_ON_15_OFF,

LED_RED_0125_ON_2075_OFF_BLUE_0625_OFF_0075_ON_15_OFF_SKIP,
LED_GREEN_0125_ON_2075_OFF_BLUE_0625_OFF_0075_ON_15_OFF_SKIP,
LED_ORANGE_0125_ON_2075_OFF_BLUE_0625_OFF_0075_ON_15_OFF_SKIP,

LED_BOTTOM_STATE
};

#define LED_E680_NAME "LED_E680_INDICATOR"

#endif /* LED_PXA_E680_H*/

